'DataGridComboBoxColumn Class for VB.NET
'Version 1.0
'쐬ҁFǂڂI http://dobon.net

Imports System
Imports System.Data
Imports System.Windows.Forms
Imports System.Drawing

Namespace Dobon.Samples.Forms
    Public Class DataGridComboBoxColumn
        Inherits DataGridTextBoxColumn
        Private _comboBox As DataGridComboBox
        Private _sorce As CurrencyManager
        Private _rowNumber As Integer
        Private _editing As Boolean

        '/ <summary>
        '/ DataGridComboBoxColumñRXgN^
        '/ </summary>
        '/ <param name="dataSource">ComboBoxDataSource</param>
        '/ <param name="displayMember">ComboBoxDisplayMember</param>
        '/ <param name="valueMember">ComboBoxValueMember</param>
        Public Sub New(ByVal dataSource As DataView, _
                ByVal displayMember As String, _
                ByVal valueMember As String)
            'ݒ
            _sorce = Nothing
            _editing = False

            'DataGridComboBox̍쐬
            _comboBox = New DataGridComboBox
            'ComboBox̐ݒ
            _comboBox.DropDownStyle = ComboBoxStyle.DropDownList
            _comboBox.Visible = False
            'f[^\[X̐ݒ
            _comboBox.DataSource = dataSource
            _comboBox.DisplayMember = displayMember
            _comboBox.ValueMember = valueMember

            'Cxgnh
            AddHandler _comboBox.Leave, AddressOf _comboBox_Leave
            AddHandler _comboBox.SelectionChangeCommitted, _
                AddressOf _comboBox_SelectionChangeCommitted
        End Sub

        'vpeB
        '/ <summary>
        '/ ǗĂ ComboBox Rg[擾܂B
        '/ </summary>
        Public ReadOnly Property ComboBox() As DataGridComboBox
            Get
                Return _comboBox
            End Get
        End Property

        'ComboBoxtH[JXꂽ
        Private Sub _comboBox_Leave(ByVal sender As Object, _
                ByVal e As EventArgs)
            If _editing Then
                'ComboBoxҏWƂ
                _editing = False
                's̒lXV
                SetColumnValueAtRow(_sorce, _rowNumber, _
                    _comboBox.Text)
                Invalidate()
            End If
            'ComboBoxB
            _comboBox.Visible = False
            'DataGrid̃XN[Cxgߑ
            AddHandler DataGridTableStyle.DataGrid.Scroll, _
                AddressOf DataGrid_Scroll
        End Sub

        'DataGridXN[
        Private Sub DataGrid_Scroll(ByVal sender As Object, _
                ByVal e As EventArgs)
            'ComboBox
            If _comboBox.Visible Then
                _comboBox.Visible = False
            End If
        End Sub

        'ComboBoxőIڂύXāA̕ύXR~bgꂽ
        Private Sub _comboBox_SelectionChangeCommitted( _
                ByVal sender As Object, ByVal e As EventArgs)
            _editing = True
            'DataGridɗ񂪕ҏWJnꂽƂm点
            MyBase.ColumnStartedEditing(CType(sender, Control))
        End Sub

        's̍ŏ̍
        Protected Overrides Function GetMinimumHeight() As Integer
            Return _comboBox.PreferredHeight
        End Function

        'ComboBoxDataGridControl.ControlCollectionɒǉ
        Protected Overrides Sub SetDataGridInColumn( _
                ByVal value As DataGrid)
            MyBase.SetDataGridInColumn(value)
            _comboBox.Parent = CType(value, Control)
        End Sub

        '񂪊ǗĂRg[ւ̃tH[JX
        'Kv邱Ƃɒʒm
        Protected Overrides Sub ConcedeFocus()
            MyBase.ConcedeFocus()
            _comboBox.Visible = False
        End Sub


        ''ҏW邽߂ɃZ
        Protected Overloads Overrides Sub Edit( _
                ByVal source As CurrencyManager, _
                ByVal rowNum As Integer, _
                ByVal bounds As Rectangle, _
                ByVal [readOnly] As Boolean, _
                ByVal instantText As String, _
                ByVal cellIsVisible As Boolean)
            '{NXEditĂяo
            MyBase.Edit(source, rowNum, bounds, [readOnly], _
                instantText, cellIsVisible)
            'TextBox
            Me.TextBox.Visible = False

            'l̕ۑ
            _rowNumber = rowNum
            _sorce = source

            '\ComboBox̐ݒ
            _comboBox.Bounds = bounds
            _comboBox.RightToLeft = _
                Me.DataGridTableStyle.DataGrid.RightToLeft

            '\Aǂݎp̂Ƃ́AComboBox\Ȃ
            If cellIsVisible AndAlso Not [readOnly] Then
                'ComboBox\
                _comboBox.Visible = True
                _comboBox.BringToFront()
                _comboBox.Focus()
            End If

            'Iڂ̕ύX
            'ComboBox\OɍsƁA
            'VsŒlύXssN
            _comboBox.SelectedIndex = _
                _comboBox.FindStringExact(Me.TextBox.Text)

            'DataGrid̃XN[Cxgߑ
            AddHandler DataGridTableStyle.DataGrid.Scroll, _
                AddressOf DataGrid_Scroll
        End Sub

        'ҏWvV[W
        Protected Overrides Function Commit( _
                ByVal dataSource As CurrencyManager, _
                ByVal rowNum As Integer) As Boolean
            If _editing Then
                'ҏŴƂ́ArowNums̒lݒ肷
                _editing = False
                SetColumnValueAtRow(dataSource, rowNum, _
                    _comboBox.Text)
            End If

            Return True
        End Function

        'w肵s̒lݒ
        Protected Overrides Sub SetColumnValueAtRow( _
                ByVal source As CurrencyManager, _
                ByVal rowNum As Integer, ByVal value As Object)
            'ValueMember̒lݒ肷
            MyBase.SetColumnValueAtRow(source, rowNum, _
                _comboBox.FindValueMember(value))
        End Sub

        'w肵s̒l擾
        Protected Overrides Function GetColumnValueAtRow( _
                ByVal source As CurrencyManager, _
                ByVal rowNum As Integer) As Object
            Dim val As Object = _
                MyBase.GetColumnValueAtRow(source, rowNum)
            'DisplayMember̒lԂ
            Return _comboBox.FindDisplayMember(val)
        End Function
    End Class

    Public Class DataGridComboBox
        Inherits System.Windows.Forms.ComboBox
        Private WM_KEYUP As Integer = &H101

        Protected Overrides Sub WndProc( _
                ByRef theMessage As System.Windows.Forms.Message)
            'L[𖳌ɂ
            If theMessage.Msg = WM_KEYUP Then
                Return
            End If
            MyBase.WndProc(theMessage)
        End Sub

        '/ <summary>
        '/ DisplayMemberValueMember̒lT
        '/ </summary>
        '/ <param name="display">TDisplayMemberl</param>
        '/ <returns>ValueMemberl</returns>
        Public Function FindValueMember( _
                ByVal display As Object) As Object
            Dim dv As DataView = CType(DataSource, DataView)
            Dim rowCount As Integer = dv.Count

            '[vĒT
            Dim disp As Object
            Dim i As Integer
            For i = 0 To rowCount - 1
                disp = dv(i)(DisplayMember)
                '
                If display.Equals(disp) Then
                    Return dv(i)(ValueMember)
                End If
            Next i
            'Ȃ
            Return DBNull.Value
        End Function

        '/ <summary>
        '/ ValueMemberDisplayMember̒lT
        '/ </summary>
        '/ <param name="value">TValueMemberl</param>
        '/ <returns>DisplayMemberl</returns>
        Public Function FindDisplayMember( _
                ByVal value As Object) As Object
            Dim dv As DataView = CType(DataSource, DataView)
            Dim rowCount As Integer = dv.Count

            '[vĒT
            Dim val As Object
            Dim i As Integer
            For i = 0 To rowCount - 1
                val = dv(i)(ValueMember)
                '
                If value.Equals(val) Then
                    Return dv(i)(DisplayMember)
                End If
            Next i
            'Ȃ
            Return DBNull.Value
        End Function
    End Class
End Namespace